---
title: Cross-global fetch usage
slug: Web/API/Fetch_API/Cross-global_fetch_usage
tags:
  - Cross global
  - Fetch
  - edge case
  - relative URL
---
<p>{{DefaultAPISidebar("Fetch API")}}</p>

<p class="summary">This article explains an edge case that occurs with fetch (and potentially other APIs exhibiting the same kind of resource retrieval behavior). When a cross-origin fetch involving a relative URL is initiated from an {{htmlelement("iframe")}}, the relative URL used to be resolved against the current global location, rather than the iframe's location.</p>

<h2 id="The_edge_case">The edge case</h2>

<p>Many sites will never come up against this edge case. To see it:</p>

<ul>
	<li>You need a same-origin iframe</li>
	<li>That same-origin iframe needs to have a location with a different base URL</li>
	<li>You have to use the fetch function cross-global, e.g. <code>frame.contentWindow.fetch()</code></li>
	<li>The URL passed to fetch needs to be relative</li>
</ul>

<h2 id="The_problem">The problem</h2>

<p>In the past we would resolve the relative URL against the current global, for example:</p>

<pre class="brush: js notranslate">let absolute = new URL(relative, window.location.href)</pre>

<p>This is not a problem as such. It is just that different APIs that exhibit this kind of behavior were doing it inconsistently with the behavior defined in the spec, which could lead to problems further down the line.</p>

<h2 id="The_solution">The solution</h2>

<p>In Firefox 60 onwards, Mozilla resolves the relative URL against the global that owns the <code>fetch()</code> function being used (see {{bug(1432272)}}). So in the case described above, it is resolved against the iframe's location:</p>

<pre class="brush: js notranslate">let absolute = new URL(relative, frame.contentWindow.location.href)</pre>

<p>There is a lot of discussion in progress about getting new specs to align with this behavior change, to mitigate potential problems going forward.</p>
